/****************************************************************************

    file.c --


****************************************************************************/

#include <windows.h>
#include <mmsystem.h>
#include <digitalv.h>
#include <viewer.h>
#include <string.h>
#include <commdlg.h>
#include <stdlib.h>

#include "..\dll\hotspot.h"
#include "avihed.h"            /* specific to this program          */
#include "avihede.h"            // extern vars

/****************************************************************************
    FUNCTION: FileOpen(HWND)

    PURPOSE: Prompts for AVI and INI files; loads selected files.
             Returns FALSE if didn't get an AVI file,
             Returns TRUE even if didn't get an INI file but got an AVI file.
****************************************************************************/
BOOL FileOpen(HWND hWnd)
{    
    static OPENFILENAME ofn;
    char szBuf[129];
    char szFileName[MAXFILENAME] = "";
    char szFileTitle[MAXFILENAME] = "";
    char szFilterSpec [128] =                       /* file type filters */
             "AVI Files (*.AVI)\0*.AVI\0All Files (*.*)\0*.*\0";
    char szFilterSpec2 [128] = 
            "Hotspot Files (*.INI)\0*.INI\0All Files (*.*)\0*.*\0";

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hWnd;
    ofn.lpstrFilter       = szFilterSpec;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFileName;
    ofn.nMaxFile          = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = "Open AVI File";
    ofn.lpstrDefExt       = "AVI";
    ofn.Flags             = 0;
    
    if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
            return FALSE;    
    
    if (pMovieInfo)                                     // get rid of old stuff if there is
        {
        fileCloseMovie(pMovieInfo, TRUE);
        DeleteHotspotList(pMovieInfo);
        FREE(pMovieInfo);
        }
            
    lstrcpy(szWindowTitle, szBaseWindowTitle);
                    lstrcat(szWindowTitle, " - ");
                    lstrcat(szWindowTitle, szFileTitle);
    
    SetWindowText(hWnd, szWindowTitle);                
    
    pMovieInfo = (PMOVIEINFO) ALLOCATE(sizeof(MOVIEINFO));
    
    if (!pMovieInfo)
        return (FALSE);
    
    pMovieInfo->hwndParent = hWnd;
    lstrcpy(pMovieInfo->szAVIFileName, ofn.lpstrFile);
    
    fileOpenMovie(pMovieInfo, ofn.lpstrFile);    
    
    playMovie(pMovieInfo, 0);    
    setMovie(pMovieInfo, pMovieInfo->dwCurrentFrame, NULL);
    
    {
    RECT rcClient, rcWindow;
    MCI_DGV_RECT_PARMS   mciRect;
    BOOL retcode = TRUE;
    
    /* if there is no movie yet then just get out of here */
    GetClientRect(hWnd, &rcClient);  /* get the parent windows rect */
    GetWindowRect(hWnd, &rcWindow);
    mciSendCommand(pMovieInfo->wMCIDeviceID, MCI_WHERE,
                  (DWORD)(MCI_DGV_WHERE_SOURCE),
                  (DWORD)(LPMCI_DGV_RECT_PARMS)&mciRect);
    
/*    SetWindowPos(hWnd, HWND_TOP, rcWindow.left, rcWindow.top,
                                    mciRect.rc.right - mciRect.rc.left
                                    + GetSystemMetrics(SM_CXBORDER) * 2,
                                    mciRect.rc.bottom - mciRect.rc.top 
                                    + GetSystemMetrics(SM_CYCAPTION)
                                    + GetSystemMetrics(SM_CYMENU)
                                    + GetSystemMetrics(SM_CYBORDER) * 2,
                                    SWP_NOZORDER);
*/
                                        
    }
    
    pMovieInfo->fPlaying = FALSE;

    bFileLoaded = TRUE;
    wsprintf(szBuf, "%ld of %ld", pMovieInfo->dwCurrentFrame,
                    pMovieInfo->dwMovieLength);
    SetDlgItemText(hwndDlg, ID_CURRENTFRAME, szBuf);
    
    // now try opening an INI file
    
    memset(szFileName, 0, sizeof(szFileName));
    memset(szFileTitle, 0, sizeof(szFileTitle));
    memset(&ofn, 0, sizeof(OPENFILENAME));
    
    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hWnd;
    ofn.lpstrFilter       = szFilterSpec2;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFileName;
    ofn.nMaxFile          = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = "Open Hotspot (INI) File";
    ofn.lpstrDefExt       = "INI";
    ofn.Flags             = 0;
    
    if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
            return TRUE;
    
    lstrcpy(pMovieInfo->szIniFileName, ofn.lpstrFile);
    InitHotspots(pMovieInfo, ofn.lpstrFile);
    if (pMovieInfo->pHotspotList && pMovieInfo->hwndMovie)                    
        {
        HDC hDC;
        
        hDC = GetDC(pMovieInfo->hwndMovie);
        DrawRects(hDC, pMovieInfo);            
        ReleaseDC(pMovieInfo->hwndMovie, hDC);
        }
    return TRUE;
}

/****************************************************************************
    FUNCTION: FileSave(HWND, BOOL)

    PURPOSE: 
    
            bGetFileName : forces prompting for save
****************************************************************************/
BOOL FileSave(HWND hWnd, BOOL bGetFileName)
{
    PHOTSPOT pHotspot;
    static OPENFILENAME ofn;
    static OFSTRUCT of;
    char szBuf[129];    
    char szFileTitle[MAXFILENAME] = "";
    char szFileName[MAXFILENAME] = "";
    char szFilterSpec [128] =                       /* file type filters */
             "Hotspot Files (*.INI)\0*.INI\0All Files (*.*)\0*.*\0";
    BOOL bGet = TRUE;

    if (pMovieInfo->szIniFileName)
        {
        if (lstrlen(pMovieInfo->szIniFileName))            
            {
            bGet = FALSE;            
            lstrcpy(szFileName, pMovieInfo->szIniFileName);
            }
        }
        
    if (bGetFileName)
        bGet = TRUE;
    if (bGet)
        {
        ofn.lStructSize       = sizeof(OPENFILENAME);
        ofn.hwndOwner     = hWnd;
        ofn.lpstrFilter   = szFilterSpec;
        ofn.lpstrCustomFilter = NULL;
        ofn.nMaxCustFilter    = 0;
        ofn.nFilterIndex      = 1;
        ofn.lpstrFile         = pMovieInfo->szIniFileName;
        ofn.nMaxFile          = MAXFILENAME;
        ofn.lpstrInitialDir   = NULL;
        ofn.lpstrFileTitle    = szFileTitle;
        ofn.nMaxFileTitle     = MAXFILENAME;
        ofn.lpstrTitle        = NULL;
        ofn.lpstrDefExt       = "INI";
        ofn.Flags             = OFN_OVERWRITEPROMPT;
    
        if (!GetSaveFileName ((LPOPENFILENAME)&ofn))
            {
            DWORD dw;
            dw = CommDlgExtendedError();
            dprintf("ERROR: %ld", dw);
                        return FALSE;
            }
        }    
    pHotspot = pMovieInfo->pHotspotList;
    while (pHotspot)        // check for hotspot ID's (yeah, this is redundant,
                            // but if for some reason no ID, we're out of luck)
        {
        if (!pHotspot->pszHotspotID)
            {
            MessageBox(hWnd, "Each hotspot must have a Hotspot ID.", "Error",
                        MB_OK | MB_ICONEXCLAMATION);
            return (FALSE);                        
            }
        pHotspot = pHotspot->pNext;
        }

    pHotspot = pMovieInfo->pHotspotList;
    
    if (!bGet)
        {
        lstrcpy(pMovieInfo->szIniFileName, ofn.lpstrFile);
        lstrcpy(szFileName, ofn.lpstrFile);
        }
    
    OpenFile(szFileName, &of, OF_DELETE); // delete the file before saving
    
    WritePrivateProfileString("Configuration", "Version", "1.00", szFileName);
    WritePrivateProfileString("Configuration", "Editor", "AVIHED", szFileName);
        
    while (pHotspot)
        {        
        WritePrivateProfileString("Hotspots", pHotspot->pszHotspotID, "1", szFileName);
        
        wsprintf(szBuf, "%d,%d,%d,%d", pHotspot->rc.left, pHotspot->rc.top,
                                        pHotspot->rc.right, pHotspot->rc.bottom);                                                
        WritePrivateProfileString(pHotspot->pszHotspotID, "Rect", szBuf, szFileName);
        
        if (pHotspot->pszCommand)
            WritePrivateProfileString(pHotspot->pszHotspotID, "Command",            
                        pHotspot->pszCommand, szFileName);
        else
            WritePrivateProfileString(pHotspot->pszHotspotID, "Command", "", szFileName);
            
        wsprintf(szBuf, "%ld", pHotspot->BeginFrame);         
        WritePrivateProfileString(pHotspot->pszHotspotID, "BeginFrame", szBuf, szFileName);
        
        wsprintf(szBuf, "%ld", pHotspot->EndFrame);                 
        WritePrivateProfileString(pHotspot->pszHotspotID, "EndFrame", szBuf, szFileName);
        
        wsprintf(szBuf, "%d", pHotspot->OnClick);                 
        WritePrivateProfileString(pHotspot->pszHotspotID, "OnClick", szBuf, szFileName);
        
        wsprintf(szBuf, "%d", pHotspot->ToFrame);                 
        WritePrivateProfileString(pHotspot->pszHotspotID, "ToFrame", szBuf, szFileName);        
            
        pHotspot = pHotspot->pNext;            
        }
        
    bModified = FALSE;           
    
//    lstrcpy(szWindowTitle, szBaseWindowTitle);
//    lstrcat(szWindowTitle, " - ");
//    lstrcat(szWindowTitle, szFileTitle);
    SetWindowText(hWnd, szWindowTitle);
    
    
    return TRUE;
}                
                                  

