/****************************************************************************

    PROGRAM: Avihrun.c

    PURPOSE: Avihrun 
****************************************************************************/

#include "windows.h"            /* required for all Windows applications */
#include <mmsystem.h>
#include <string.h>
#include <commdlg.h>
#include <stdlib.h>
#include "resource.h"
#include "avihrun.h"            /* specific to this program          */

#define MAXFILENAME 129

HANDLE hInst;               /* current instance              */
char szPlayFile[MAXFILENAME];
char szIniFile[MAXFILENAME];
char szAVIFile[MAXFILENAME];
char szWindowTitle[MAXFILENAME];
char szBaseWindowTitle[] = "AVI Hotspot Runtime Player";
HWND hMainWnd;
FARPROC lpfnhspAVICallback;

LPSTR FindToken(LPSTR psz, char c);
LONG CALLBACK hspPlayAVI(HWND hwnd, LPSTR szAVIFile, LPSTR szIniFile, FARPROC);
BOOL __export CALLBACK hspAVICallback(HWND hwndParent, HWND hwndMovie, WORD wMessage,
                                            LONG FAR *lParam1, LONG FAR *lParam2);
BOOL FileOpen(HWND);
BOOL RuntimeFileOpen(HWND);
BOOL Run(HWND);

BOOL Run(HWND hWnd)
{               
    if (!GetPrivateProfileString("Files", "AVI", "", szAVIFile, 128, szPlayFile)
            || !GetPrivateProfileString("Files", "Ini", "", szIniFile, 128, szPlayFile))
        {            
        MessageBox(hWnd, "Error opening Runtime Play file", "Error", MB_OK);
        return FALSE;
        }
    else                           
        hspPlayAVI(hWnd, (LPSTR)szAVIFile, (LPSTR)szIniFile, (FARPROC)lpfnhspAVICallback);

    return TRUE;
}

/****************************************************************************

    FUNCTION: WinMain(HANDLE, HANDLE, LPSTR, int)

    PURPOSE: calls initialization function, processes message loop
****************************************************************************/

int PASCAL WinMain(hInstance, hPrevInstance, lpCmdLine, nCmdShow)
HANDLE hInstance;                /* current instance         */
HANDLE hPrevInstance;            /* previous instance        */
LPSTR lpCmdLine;                 /* command line             */
int nCmdShow;                    /* show-window type (open/icon) */
{
    MSG msg;                     /* message              */

    if (!hPrevInstance)          /* Other instances of app running? */
    if (!InitApplication(hInstance)) /* Initialize shared things */
        return (FALSE);      /* Exits if unable to initialize     */

    /* Perform initializations that apply to a specific instance */

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    /* Acquire and dispatch messages until a WM_QUIT message is received. */

    lstrcpy(szPlayFile, lpCmdLine);

    while (GetMessage(&msg,    /* message structure              */
        NULL,          /* handle of window receiving the message */
        NULL,          /* lowest message to examine          */
        NULL))         /* highest message to examine         */
    {
    TranslateMessage(&msg);    /* Translates virtual key codes       */
    DispatchMessage(&msg);     /* Dispatches message to window       */
    }
    return (msg.wParam);       /* Returns the value from PostQuitMessage */
}


/****************************************************************************

    FUNCTION: InitApplication(HANDLE)

    PURPOSE: Initializes window data and registers window class
****************************************************************************/

BOOL InitApplication(hInstance)
HANDLE hInstance;                  /* current instance       */
{
    WNDCLASS  wc;

    /* Fill in window class structure with parameters that describe the       */
    /* main window.                                                           */

    wc.style = NULL;                    /* Class style(s).                    */
    wc.lpfnWndProc = MainWndProc;       /* Function to retrieve messages for  */
                                        /* windows of this class.             */
    wc.cbClsExtra = 0;                  /* No per-class extra data.           */
    wc.cbWndExtra = 0;                  /* No per-window extra data.          */
    wc.hInstance = hInstance;           /* Application that owns the class.   */
    wc.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName =  "AvihrunMenu";   /* Name of menu resource in .RC file. */
    wc.lpszClassName = "AvihrunWClass"; /* Name used in call to CreateWindow. */

    /* Register the window class and return success/failure code. */

    return (RegisterClass(&wc));

}


/****************************************************************************

    FUNCTION:  InitInstance(HANDLE, int)

    PURPOSE:  Saves instance handle and creates main window

****************************************************************************/

BOOL InitInstance(hInstance, nCmdShow)
    HANDLE          hInstance;          /* Current instance identifier.       */
    int             nCmdShow;           /* Param for first ShowWindow() call. */
{
    HWND            hWnd;               /* Main window handle.                */

    /* Save the instance handle in static variable, which will be used in  */
    /* many subsequence calls from this application to Windows.            */

    hInst = hInstance;

    /* Create a main window for this application instance.  */

    hWnd = CreateWindow(
        "AvihrunWClass",                /* See RegisterClass() call.          */
        szBaseWindowTitle,              /* Text for window title bar.         */
        WS_OVERLAPPEDWINDOW,            /* Window style.                      */
        CW_USEDEFAULT,                  /* Default horizontal position.       */
        CW_USEDEFAULT,                  /* Default vertical position.         */
        CW_USEDEFAULT,                  /* Default width.                     */
        CW_USEDEFAULT,                  /* Default height.                    */
        NULL,                           /* Overlapped windows have no parent. */
        NULL,                           /* Use the window class menu.         */
        hInstance,                      /* This instance owns this window.    */
        NULL                            /* Pointer not needed.                */
    );

    /* If window could not be created, return "failure" */

    if (!hWnd)
        return (FALSE);

    /* Make the window visible; update its client area; and return "success" */

    ShowWindow(hWnd, nCmdShow);  /* Show the window                        */
    UpdateWindow(hWnd);          /* Sends WM_PAINT message                 */
    return (TRUE);               /* Returns the value from PostQuitMessage */

}

/****************************************************************************

    FUNCTION: MainWndProc(HWND, UINT, WPARAM, LPARAM)

    PURPOSE:  Processes messages
****************************************************************************/

long CALLBACK __export MainWndProc(hWnd, message, wParam, lParam)
HWND hWnd;                      /* window handle                 */
UINT message;                   /* type of message               */
WPARAM wParam;                  /* additional information        */
LPARAM lParam;                  /* additional information        */
{
    switch (message)
    {
        case WM_CREATE: 
            lpfnhspAVICallback = MakeProcInstance(hspAVICallback, hInst);
            return TRUE;
    
        case WM_COMMAND:       /* message: command from application menu */
            switch (wParam)
                {
                case IDM_ABOUT:
                    DialogBox(hInst,        /* current instance          */
                    "AboutBox",         /* resource to use           */
                    hWnd,               /* parent handle             */
                    About);             /* About() instance address  */
                    break;

                case IDM_OPEN:
                    if (FileOpen(hWnd))
                        hspPlayAVI(hWnd, szAVIFile, szIniFile, lpfnhspAVICallback);
                    break;
                    
                case IDM_OPENR:
                    RuntimeFileOpen(hWnd);                        
                case IDM_RUN:
                    Run(hWnd);
                    break;                    
                    
                case IDM_EXIT:
                    PostMessage(hWnd, WM_CLOSE, 0, 0L);
                    break;                    

                default:                    
                    return (DefWindowProc(hWnd, message, wParam, lParam));
                }
            break;                                    

        case WM_DESTROY:          /* message: window being destroyed */
            FreeProcInstance(lpfnhspAVICallback);
            PostQuitMessage(0);
            break;

        default:                  /* Passes it on if unproccessed    */
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (NULL);
}


/****************************************************************************

    FUNCTION: About(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages for "About" dialog box
****************************************************************************/
BOOL __export CALLBACK About(hDlg, message, wParam, lParam)
HWND hDlg;               /* window handle of the dialog box */
unsigned message;        /* type of message                 */
WORD wParam;             /* message-specific information    */
LONG lParam;
{
    switch (message)
    {
        case WM_INITDIALOG:            /* message: initialize dialog box */
            return (TRUE);

        case WM_COMMAND:               /* message: received a command */
            if (wParam == IDOK         /* "OK" box selected?          */
                || wParam == IDCANCEL) /* System menu close command?  */
            {
                EndDialog(hDlg, TRUE); /* Exits the dialog box        */
                return (TRUE);
            }
            break;
    }
    return (FALSE);               /* Didn't process a message    */
}

/****************************************************************************

    FUNCTION: hspAVICallback(LPSTR, LPSTR)

    PURPOSE:  Command processor
    
    NOTES:      Currently supports two commands, sndPlaySound and ExecProgram
                which have the same syntax as their Viewer conterparts.
****************************************************************************/
BOOL __export CALLBACK hspAVICallback(HWND hwndParent, HWND hwndMovie, 
                                WORD wMessage, LONG FAR * lParam1, LONG FAR *lParam2)
{    
    char szCommand[129];
    int pos;
    LPSTR token;

    switch (wMessage)
        {
        case WM_SIZE:
            {
            BOOL bMenu = FALSE;
            RECT FAR *rcMovie;
            RECT rcParent;
            int x,y;
            
            if (!lParam1)
                return FALSE;
            
            rcMovie = (RECT FAR *)lParam1;

            if (GetMenu(hwndParent))
                bMenu = TRUE;

            GetWindowRect(hwndParent, &rcParent);

            x = GetSystemMetrics(SM_CXSCREEN);            
            y = GetSystemMetrics(SM_CYSCREEN);
            x = x /2;
            y = y /2;
            x = x - ((rcMovie->right - rcMovie->left) / 2);
            y = y - ((rcMovie->bottom - rcMovie->top) / 2);
            
            AdjustWindowRect(rcMovie, GetWindowLong(hwndParent, GWL_STYLE), bMenu);                        
            MoveWindow(hwndParent,  x,
                                    y, 
                                    rcMovie->right - rcMovie->left,
                                    rcMovie->bottom - rcMovie->top,                                            
                                    TRUE);                                                
            }
            return TRUE;
        
        case WM_LBUTTONDOWN:    
            {
            LPSTR pszHotspotID = (LPSTR)lParam1;
            LPSTR pszCommand = (LPSTR)lParam2;
        
            pos = _fstrcspn(pszCommand, "( ");
            lstrcpyn(szCommand, pszCommand, pos+1);        
            if (0 == lstrcmp(szCommand, "sndPlaySound"))
                {
                LPSTR lpszSoundName;
        
                token = FindToken(pszCommand, '`');
                lpszSoundName = FindToken(NULL, '\'');        
                sndPlaySound(lpszSoundName, SND_ASYNC);
                }                
            if ((0 == lstrcmp(szCommand, "ExecProgram")) || (0 == lstrcmp(szCommand, "WinExec")))
                {
                LPSTR lpszCmdLine;
        
                token = FindToken(pszCommand, '`');
                lpszCmdLine = FindToken(NULL, '\'');
                WinExec(lpszCmdLine, SW_SHOWNORMAL);
                }                
            }                
            return TRUE;
            
        default:
            return FALSE;
        }            

    return FALSE;
}

/****************************************************************************
    FUNCTION: FileOpen(HWND)

    PURPOSE: Prompts for AVI and INI files; loads selected files.
             Returns FALSE if didn't get an AVI file,
             Returns TRUE even if didn't get an INI file but got an AVI file.
****************************************************************************/
BOOL FileOpen(HWND hWnd)
{    
    static OPENFILENAME ofn;
    char szFileName[MAXFILENAME] = "";
    char szFileTitle[MAXFILENAME] = "";
    char szFilterSpec [128] =                       /* file type filters */
             "AVI Files (*.AVI)\0*.AVI\0All Files (*.*)\0*.*\0";
    char szFilterSpec2 [128] = 
            "Hotspot Files (*.INI)\0*.INI\0All Files (*.*)\0*.*\0";

    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hWnd;
    ofn.lpstrFilter       = szFilterSpec;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFileName;
    ofn.nMaxFile          = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = "Open AVI File";
    ofn.lpstrDefExt       = "AVI";
    ofn.Flags             = 0;
    
    if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
            return FALSE;    
    
    lstrcpy(szWindowTitle, szBaseWindowTitle);
                    lstrcat(szWindowTitle, " - ");
                    lstrcat(szWindowTitle, szFileTitle);
    
    SetWindowText(hWnd, szWindowTitle);                
    lstrcpy(szAVIFile, ofn.lpstrFile);
    
    // now try opening an INI file
    
    memset(szFileName, 0, sizeof(szFileName));
    memset(szFileTitle, 0, sizeof(szFileTitle));
    memset(&ofn, 0, sizeof(OPENFILENAME));
    
    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hWnd;
    ofn.lpstrFilter       = szFilterSpec2;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFileName;
    ofn.nMaxFile          = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = "Open Hotspot (INI) File";
    ofn.lpstrDefExt       = "INI";
    ofn.Flags             = 0;
    
    if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
            return TRUE;
            
    lstrcpy(szIniFile, ofn.lpstrFile);            
    
    return TRUE;
}

BOOL RuntimeFileOpen(HWND hWnd)
{    
    static OPENFILENAME ofn;
    char szFileName[MAXFILENAME] = "";
    char szFileTitle[MAXFILENAME] = "";
    char szFilterSpec [128] =                       /* file type filters */
             "Runtime Play Files (*.INI)\0*.INI\0All Files (*.*)\0*.*\0";
    ofn.lStructSize       = sizeof(OPENFILENAME);
    ofn.hwndOwner         = hWnd;
    ofn.lpstrFilter       = szFilterSpec;
    ofn.lpstrCustomFilter = NULL;
    ofn.nMaxCustFilter    = 0;
    ofn.nFilterIndex      = 1;
    ofn.lpstrFile         = szFileName;
    ofn.nMaxFile          = MAXFILENAME;
    ofn.lpstrInitialDir   = NULL;
    ofn.lpstrFileTitle    = szFileTitle;
    ofn.nMaxFileTitle     = MAXFILENAME;
    ofn.lpstrTitle        = "Open Runtime Play File";
    ofn.lpstrDefExt       = "AVI";
    ofn.Flags             = 0;
    
    if (!GetOpenFileName ((LPOPENFILENAME)&ofn))
            return FALSE;    
            
    lstrcpy(szPlayFile, ofn.lpstrFile);            
    
    return TRUE;
}
