/*****************
        
        sbcls.c --
    
*****************/
#include <windows.h>
#include <mmsystem.h>
#include <digitalv.h>
#include <viewer.h>
#include <string.h>

#include "hotspot.h"

// define VIEWER for use with VIEWER (i.e. for vwrCommand() )

extern char szMovieInfo[];

/*********************************************************************************************
    FUNCTION:   Terminate(PMOVIEINFO)
    
    PURPOSE:    stops playing the movie and closes it    
*********************************************************************************************/ 
void Terminate(PMOVIEINFO pMovieInfo)
{
    playMovie(pMovieInfo, 0);
    fileCloseMovie(pMovieInfo, FALSE);    
}

/*********************************************************************************************
    FUNCTION:   OnButtonDown(PMOVIEINFO, USHORT, USHORT, LONG)
    
    PURPOSE:    Checks if clicked point is in rect, if it is then executes viewer command
*********************************************************************************************/ 
BOOL OnButtonDown(PMOVIEINFO pMovieInfo, USHORT msg, USHORT wp, LONG lp)
{
    PHOTSPOT pHotspot;
    DWORD dwFrame;                      
    POINT pt;
    HWND hwnd;
    
    if (!pMovieInfo)
        return FALSE;
    
    pHotspot = pMovieInfo->pHotspotList;
    pt = MAKEPOINT(lp);
    dwFrame = GetMovieFrame(pMovieInfo);
    
    while (pHotspot)
        {        
        if (dwFrame >= pHotspot->BeginFrame && dwFrame <= pHotspot->EndFrame)
            {
            if (PtInRect(&pHotspot->rc, pt) != 0)
                {                
#ifdef VIEWER  // rewrite this to deal with VIEWER/VBX/whatever on the fly                                      
                hwnd = GetParent(pMovieInfo->hwndParent);
                if (!hwnd)
                    hwnd = pMovieInfo->hwndParent;
                VwrCommand(VwrFromHinst(GetWindowWord(hwnd, GWW_HINSTANCE)),
                                NULL, pHotspot->pszCommand, cmdoptNONE);
#endif
#ifdef AVIHAPP
                if (pMovieInfo->lpfnhspAVICallback) // call the callback function
                    {                    
                    pMovieInfo->lpfnhspAVICallback (pMovieInfo->hwndParent,
                                                pMovieInfo->hwndMovie,
                                                WM_LBUTTONDOWN, 
                                                pHotspot->pszHotspotID, 
                                                pHotspot->pszCommand);                        
                    }                
#endif
#ifdef AVIHVB

           // well.. hmmm... VB can't easily accept new messages
                // maybe write a VBX control to subclass the form it's on
                // to intercept a WM_USER or WM_COMMAND message of some sort...
                //
                //
#endif
                switch (pHotspot->OnClick)
                    {
                    case ID_CONTINUE:
                        return (TRUE);                        
                    case ID_STOP:
                        return (FALSE);
                    case ID_JUMP:
                        setMovie(pMovieInfo, pHotspot->ToFrame, NULL);
                        pMovieInfo->dwCurrentFrame = pHotspot->ToFrame;
                        pMovieInfo->fPlaying = FALSE;
                        playMovie(pMovieInfo, 1);
                        return (TRUE);                        
                    default:
                        return (TRUE);                                            
                    }                                
                }
            }
        pHotspot = pHotspot->pNext;                        
        }
    return (TRUE);        
}

/*********************************************************************************************
    FUNCTION:   SbClsProc(HWND, USHORT, USHORT, LONG)
    
    PURPOSE:    subclasses the movie window    
*********************************************************************************************/ 
LONG FAR PASCAL _export SbClsProc (HWND hwnd, USHORT msg,
     USHORT wp, LONG lp)
{
    HANDLE hglb;
    PMOVIEINFO pMovieInfo;
    LRESULT lr;
    
    hglb = GetProp(hwnd, (LPSTR)szMovieInfo);
    if (!hglb)
        {
        dprintf("ERROR: Invalid global memory handle (no window property)");
        }
    pMovieInfo = (PMOVIEINFO)GlobalLock(hglb);
    
    switch (msg)
    {   
        case WM_LBUTTONDOWN:            
            if (0 == (OnButtonDown(pMovieInfo, msg, wp, lp)))                
                {
                Terminate(pMovieInfo);
                return 0L;
                }        
            break;            
    
        case MM_MCINOTIFY:
            /* This is where we check the status of an AVI  */
            /* movie that might have been playing.  We do   */
            /* the play with MCI_NOTIFY on so we should get */
            /* a MCI_NOTIFY_SUCCESSFUL if the play      */
            /* completes on it's own.           */
            switch(wp){
                case MCI_NOTIFY_SUCCESSFUL:
                    /* the play finished, let's rewind */
                    /* and clear our flag.         */                
                    pMovieInfo->fPlaying = FALSE;
                    Terminate(pMovieInfo);
                    return 0L;
                }
            break;            
    
        case WM_DESTROY:            
            RemoveProp(hwnd, (LPSTR)szMovieInfo);
            if (pMovieInfo)                                
                DeleteHotspotList(pMovieInfo);                
            
            if (pMovieInfo)               
                SetWindowLong (hwnd, GWL_WNDPROC,
                        (LONG) pMovieInfo->lpfnOldProc);
            GlobalUnlock(hglb);
            GlobalFree(hglb);
            hglb = NULL;
            pMovieInfo = NULL;            
        break;
    }   

    if (pMovieInfo)
        {
        lr = CallWindowProc(pMovieInfo->lpfnOldProc, hwnd, msg, wp, lp);
        if (hglb)
            GlobalUnlock(hglb);
        return (lr);
        }
    else
        return 0L;
}
