/*************
    
    debug.c --
    
*************/ 
#include <windows.h>

#include "hotspot.h"

#ifdef DEBUG

//
// Set the current debug level
//

void SetDebugLevel(int i)
{
    __iDebugLevel = i;
    dprintf("Debug Level set to %d", i);
}

//
// Show a message box with assertion failure info in it
//

void __AssertMsg(LPSTR exp, LPSTR file, int line)
{
    char buf[256];
    int i;

    wsprintf(buf, 
             "Exp: %s\nFile: %s, Line %d",
             (LPSTR)exp,
             (LPSTR)file,
             line);
    i = MessageBox(NULL,
                   buf,
                   "Assertion failure", 
                   MB_OK | MB_ICONEXCLAMATION);
}

#endif

//
// function to add a string to the end of the debug list
//

void cdecl DbgOut(LPSTR lpFormat, ...) 
{
    char buf[256];

    // format the string

    wvsprintf(buf, lpFormat, (LPSTR)(&lpFormat+1));
    
    // output the string.  NOTE: This REQUIRES DBWin to be running
    // (but does not require the debug kernel).
    OutputDebugString(buf);
    OutputDebugString("\r\n");
}
