/****************************

    hotspot.c --
    
***************************/    
#include <windows.h>
#include <mmsystem.h>
#include <digitalv.h>
#include <viewer.h>
#include <string.h>
#include <direct.h>

#include "hotspot.h"

// define VIEWER for use with VIEWER (i.e. for vwrCommand() )

extern char szMovieInfo[];


/*********************************************************************************************
    FUNCTION:   hspPlayAVI(HWND, LPSTR, LPSTR)
    
    PURPOSE:    Plays the AVI file specified by szAVIFile into the specified window using 
                the hotspot information in szIniFile.              
*********************************************************************************************/
#ifdef VIEWER
LONG CALLBACK __export hspPlayAVI(HWND hwnd, LPSTR szAVIFile, LPSTR szIniFile)
#endif
#ifdef AVIHAPP
LONG CALLBACK __export hspPlayAVI(HWND hwnd, LPSTR szAVIFile, 
                                    LPSTR szIniFile, FARPROC lpfnhspAVICallback)
#endif                                    
#ifndef VIEWER
 #ifndef AVIHAPP 
    LONG CALLBACK __export hspPlayAVI(HWND hwnd, LPSTR szAVIFile, 
                                    LPSTR szIniFile, FARPROC lpfnhspAVICallback)
 #endif                                    
#endif
{
    HGLOBAL hglb;
    PMOVIEINFO pMovieInfo;
    
    hglb = GlobalAlloc(GHND, sizeof(MOVIEINFO));
    pMovieInfo = (PMOVIEINFO)GlobalLock(hglb);
    
    if (!pMovieInfo)
        return (0L);
    
    pMovieInfo->hwndParent = hwnd;
#ifdef AVIHAPP    
    pMovieInfo->lpfnhspAVICallback = lpfnhspAVICallback;
#endif    
    
    if (!hwnd)
        {
        MessageBox(NULL, "Invalid window specified for playing AVI file.",
                         "Error", MB_OK | MB_ICONHAND);
        return 0L;
        }
        
    InitHotspots(pMovieInfo, szIniFile);
    
    fileOpenMovie(pMovieInfo, szAVIFile);
    GlobalUnlock(hglb);

#ifndef VBX
    pMovieInfo->lpfnOldProc = (FARPROC) GetWindowLong (pMovieInfo->hwndMovie, GWL_WNDPROC);
    SetWindowLong (pMovieInfo->hwndMovie, GWL_WNDPROC, (LONG) SbClsProc);
    SetProp(pMovieInfo->hwndMovie, (LPSTR) szMovieInfo, hglb);    
#endif    
        
    playMovie(pMovieInfo, 1);
    
    return (0L);
}

