/*********************
   
    main.c --
    
*********************/
#include <windows.h>
#include <mmsystem.h>
#include <digitalv.h>
#include <viewer.h>
#include <string.h>

#ifdef VBX
 #ifndef VB_VERSION
  #include <vbapi.h>
 #endif  
#endif 

#include "hotspot.h"
#include "avivbx.h"

void Terminate(PMOVIEINFO pMovieInfo);
void InitMovieInfo();
int GetFreeMovieInfo();
void DestroyMovieInfo(int i);
PMOVIEINFO PMovieInfoFromHCtl(HCTL hctl);

static int cVbxUsers = 0;
HANDLE hmodDLL;
static BOOL bInit = FALSE;
extern MOVIEINFO FAR MovieInfo[10];


// define VIEWER for use with VIEWER (i.e. for vwrCommand() )

/*********************************************************************************************
    FUNCTION:   LDLLHandler(UINT, LONG, LONG)
    
    PURPOSE:    Called by viewer on init of DLL    
*********************************************************************************************/ 
LONG CALLBACK LDLLHandler(UINT msg, LONG lParam1, LONG lParam2)
{
    switch (msg)
    {
    case DW_WHATMSG:        
        return DC_INITTERM;
        
    case DW_INIT:    
       return TRUE;
        
    case DW_TERM:
        return 0;
    }
}

VOID InitVBX()
{    
    if (!bInit)
        {        
        InitMovieInfo();
        }
}

/*********************************************************************************************
    FUNCTION:   LibMain(HANDLE, int, LPSTR)
    
    PURPOSE:    Calls initAVI() on library loading    
*********************************************************************************************/ 
BOOL CALLBACK LibMain(HANDLE hModule, int cbHeap, LPSTR lpchCmdLine)
{    

    hmodDLL = hModule;
    initAVI();
    
    return TRUE;
}

/*********************************************************************************************
    FUNCTION:   WEP(int)
    
    PURPOSE:    Called when DLL is unloaded    
*********************************************************************************************/ 
int CALLBACK WEP(int nExitType)
{
    termAVI();    
    
    return (TRUE);
}

#ifdef VBX

VOID NEAR FireAdjustSize(HCTL hctl, WORD cx, WORD cy)
{                                                         
    SIZEADJUSTPARAMS params;
    
    params.CX = &cx;
    params.CY = &cy;
    VBFireEvent(hctl, IEVENT_AVI_SIZEADJUST, &params);
    return;
}

VOID NEAR FireHspClick(HCTL hctl, PHOTSPOT pHotspot)
{ 
    HSPCLICKPARAMS params;
    
    params.hlszHotspotID = VBCreateHlstr(pHotspot->pszHotspotID,
                                            lstrlen(pHotspot->pszHotspotID));
    VBFireEvent(hctl, IEVENT_AVI_HSPCLICK, &params);
    VBDestroyHlstr(params.hlszHotspotID);
    return;        
}

//---------------------------------------------------------------------------
// Register custom control. This routine is called by VB when the custom
// control DLL is loaded for use.
//---------------------------------------------------------------------------
BOOL FAR PASCAL _export VBINITCC
(
    USHORT usVersion,
    BOOL   fRuntime
)
{
    // Avoid warnings on unused (but required) formal parameters
    fRuntime  = fRuntime;
    usVersion = usVersion;
    
    ++cVbxUsers;
    OutputDebugString("VBINITCC\r\n");
    InitVBX();
    
    // Register control(s)
    return VBRegisterModel(hmodDLL, &modelSprites);
}


VOID FAR PASCAL _export VBTERMCC(VOID)
{
    --cVbxUsers;
    OutputDebugString("VBTERMCC\r\n");
    return;
}         

#endif VBX


/*********************************************************************************************
    FUNCTION:   AVICtlProc(HWND, USHORT, USHORT, LONG)
    
    PURPOSE:    subclasses the movie window    
*********************************************************************************************/ 
LONG FAR PASCAL _export AVICtlProc (
    HCTL   hctl,
    HWND   hwnd,
    USHORT msg,
    USHORT wp,
    LONG   lp
)

{
    HANDLE hglb;
    PMOVIEINFO pMovieInfo;
    LRESULT lr;
    
    switch (msg)
    {   
        case WM_CREATE:
            dprintf("WM_CREATE");
            {            
            PMOVIEINFO pMovieInfo;
            int i;
            i = GetFreeMovieInfo();            
            MovieInfo[i].bLoading = TRUE;
            MovieInfo[i].hctl = hctl;
            }                                                        
            break;

        case WM_PAINT:
            {
            HDC hDC;
            PAINTSTRUCT ps;
            MCI_DGV_UPDATE_PARMS mciUpdate;
            
            hDC = BeginPaint(hwnd, &ps);
            pMovieInfo = PMovieInfoFromHCtl(hctl);
            if (pMovieInfo)                         // if we have a movie, update the window
                {                                   // with the current frame
                mciUpdate.hDC = hDC;
                mciUpdate.rc = ps.rcPaint;
                mciUpdate.wReserved0 = 0;
                mciUpdate.dwCallback = NULL;
                mciSendCommand(pMovieInfo->wMCIDeviceID, MCI_UPDATE, 
                            MCI_WAIT | MCI_DGV_RECT | MCI_DGV_UPDATE_PAINT | MCI_DGV_UPDATE_HDC,
                            (DWORD)(LPMCI_DGV_UPDATE_PARMS)&mciUpdate);
                }
            EndPaint(hwnd, &ps);                            
            }
            return TRUE;
    
        case WM_LBUTTONDOWN:            
            pMovieInfo = PMovieInfoFromHCtl(hctl);
            if (0 == (OnButtonDown(pMovieInfo, msg, wp, lp)))                
                {
                Terminate(pMovieInfo);
                return 0L;
                }        
            break;            
    
        case MM_MCINOTIFY:
            /* This is where we check the status of an AVI  */
            /* movie that might have been playing.  We do   */
            /* the play with MCI_NOTIFY on so we should get */
            /* a MCI_NOTIFY_SUCCESSFUL if the play      */
            /* completes on it's own.           */
            switch(wp){
                case MCI_NOTIFY_SUCCESSFUL:
                    {                    
                    char szBuf[129];
                    
                    pMovieInfo = PMovieInfoFromHCtl(hctl);
                    
                    pMovieInfo->fPlaying = FALSE;
                    OutputDebugString("MCI_NOTIFY_SUCCESSFUL");
                    Terminate(pMovieInfo);
                    OutputDebugString("after terminate");
                    VBInvalidateRect(hctl, NULL, TRUE);
                    VBUpdateControl(hctl);
                    return 0L;
                    }
                }
            break;            

        case WM_DESTROY:
            {            
            pMovieInfo = PMovieInfoFromHCtl(hctl);
            if (pMovieInfo)
                {
                DeleteHotspotList(pMovieInfo);
                pMovieInfo->hctl = NULL;            
                }
            if (pCtlInfoDEREF(hctl)->hszAVIFile)               // if we have string handles, free them
                VBDestroyHsz(pCtlInfoDEREF(hctl)->hszAVIFile);
            if (pCtlInfoDEREF(hctl)->hszIniFile)               // if we have string handles, free them
                VBDestroyHsz(pCtlInfoDEREF(hctl)->hszIniFile);
                            
            }
            break;

        case VBM_INITIALIZE:
            OutputDebugString("VBM_INITIALIZE\r\n");
            break;
            
        case VBM_LOADED:        
            {
            pMovieInfo = PMovieInfoFromHCtl(hctl);
            pMovieInfo->bLoading = FALSE;
            OutputDebugString("VBM_LOADED");
            }
            break;                    
            
        case VBM_SETPROPERTY:                               // VB message: set a property        
            dprintf("HCTL, HWND = %d %d", hctl, hwnd);
            dprintf("VBM_SETPROPERTY");
            switch (wp)
                {                
                case IPROP_AVI_AVIFILE:
                    dprintf("IPROP_AVI_AVIFILE");
                    {                    
                    LPSTR lpstr = VBDerefHsz(pCtlInfoDEREF(hctl)->hszAVIFile);
                    pMovieInfo = PMovieInfoFromHCtl(hctl);
                    
                    if (lpstr && lstrlen(lpstr))
                        {                            
                        lstrcpy(pMovieInfo->szAVIFileName, lpstr);
                        }
                    }
                    break;                        
                        
                case IPROP_AVI_INIFILE:
                    dprintf("IPROP_AVI_INIFILE");
                    {                    
                    LPSTR lpstr = VBDerefHsz(pCtlInfoDEREF(hctl)->hszIniFile);
                    pMovieInfo = PMovieInfoFromHCtl(hctl);                    
                    
                    if (lpstr && lstrlen(lpstr))
                        {                            
                        lstrcpy(pMovieInfo->szIniFileName, lpstr);
                        }
                    }
                    break;
                    
                case IPROP_AVI_PLAY:                
                    dprintf("IPROP_AVI_PLAY");
                    {
                    pMovieInfo = PMovieInfoFromHCtl(hctl);
                    InitHotspots(pMovieInfo, pMovieInfo->szIniFileName);
                    pMovieInfo->hwndParent = hwnd;
                    fileOpenMovie(pMovieInfo, pMovieInfo->szAVIFileName);
                    playMovie(pMovieInfo, 1);
                    }
                    break;                    
                }
            break;        
    }   
    return VBDefControlProc(hctl, hwnd, msg, wp, lp);

}
